/* Tatsuo Saeki : date 1998/03/28 */

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <fcntl.h>

static void ibm_to_float(char from[], int to[], int n, int k);

main(argc, argv)
	int		argc;
	char		**argv;
{	
	int		tape;
	FILE		*out;
	FILE		*log;
	FILE		*pipefp;
	char		str_su0[200];
	char		str_su1[200];
	char		str_asc[200];
	char		str_bin[200];
	char		str_log[200];
	char		cmdbuf[200];
	int		MBUF=256*1024;
	int		NBUF;
	int		nbuf;
	int		mbuf;
	int		nrec;
	int		ntrc;
	char		abuf[3200];
	char		bbuf[400];
	char		dbuf[MBUF];
	int		ebuf[(MBUF-240)/4];
	int		mode;
	int		endian;
	int		i;
	int		j;

	if(!((argc>=3)&&(argc<=5))) {
		fprintf(stderr,"Usage: %s in out mode endian\n",*argv);
		fprintf(stderr,"   in ........ input\n");
		fprintf(stderr,"   out ....... output\n");
		fprintf(stderr,"                out.su ---- sudata\n");
		fprintf(stderr,"                out.hed --- ascii header\n");
		fprintf(stderr,"                out.bin --- binary header\n");
		fprintf(stderr,"                out.log --- logfile\n");
		fprintf(stderr,"   mode ...... choice of input device (option)\n");
		fprintf(stderr,"                0 = open reel or 8mm(degault)\n");
		fprintf(stderr,"                1 = disk\n");
		fprintf(stderr,"   endian .... choice of endian type (option)\n");
		fprintf(stderr,"                0 = big endian (default)\n");
		fprintf(stderr,"                1 = little endian\n");
		exit(1);
	}

	sprintf(str_su0,"%s.su",argv[2]);	/* su format file	*/
	sprintf(str_asc,"%s.hed",argv[2]);	/* ascii header file	*/
	sprintf(str_bin,"%s.bin",argv[2]);	/* binary header file	*/
	sprintf(str_log,"%s.log",argv[2]);	/* log file		*/
	tape=open(argv[1],O_RDONLY,0);
	if(argc>=4) {
		mode=atoi(argv[3]);
		if(mode!=1) mode=0;
	} else {
		mode=0;
	}
	if(argc==5) {
		endian=atoi(argv[4]);
		if(endian!=1) endian=0;
	} else {
		endian=0;
	}

	nbuf=read(tape,abuf,3200);
	if(nbuf<0) {
		fprintf(stderr,"can't read ebsdec-header\n"); exit(1);
	} else if(nbuf==0) {
		fprintf(stderr,"unexpected eof in ebsdec-header\n"); exit(1);
	} else if(nbuf!=3200) {
		fprintf(stderr,"unexpected size in ebsdec-header\n"); exit(1);
	} else {
		if((out=fopen((char *)str_asc,"w"))==NULL) {
			fprintf(stderr,"can't create %s\n",str_asc); exit(1);
		} else {
			sprintf(cmdbuf,"dd of=%s ibs=3200 cbs=80 conv=ascii",str_asc);
			pipefp = popen(cmdbuf, "w");
			fwrite(abuf,3200,1,pipefp);
			pclose(pipefp);
			fclose(out);
			fprintf(stderr,"%s  : ascii-header-file\n",str_asc);
		}
		if((log=fopen((char *)str_log,"w"))==NULL) {
			fprintf(stderr,"can't create %s\n",str_log); exit(1);
		} else {
			fprintf(log,"%s  : ascii-header-file\n",str_asc);
		}
	}

	nbuf=read(tape,bbuf,400);
	if(nbuf<0) {
		fprintf(stderr,"can't read binary-header\n"); exit(1);
	} else if(nbuf==0) {
		fprintf(stderr,"unexpected eof in binary-header\n"); exit(1);
	} else if(nbuf!=400) {
		fprintf(stderr,"unexpected size in binary-header\n"); exit(1);
	} else {
		if((out=fopen((char *)str_bin,"w"))==NULL) {
			fprintf(stderr,"can't create %s\n",str_bin); exit(1);
		} else {
			if(endian==0) {
				fwrite(bbuf,sizeof(char),400,out);
			} else {
				for(i=0;i<3;++i) for(j=0;j<4;++j)
					fwrite(&bbuf[i*4-j+4-1],sizeof(char),1,out);
				for(i=0;i<194;++i) for(j=0;j<2;++j)
					fwrite(&bbuf[i*2-j+2-1+12],sizeof(char),1,out);
			}
			fclose(out);
			fprintf(stderr,"%s  : binary-header-file\n",str_bin);
		}
		fprintf(log,"%s  : binary-header-file\n",str_bin);
	}

	if(mode==1) {
		NBUF  = (bbuf[20]<<8) & 0x0000ff00;
		NBUF += (bbuf[21]) & 0x000000ff;
		NBUF  = NBUF*4+240;
	} else {
		NBUF  = MBUF;
	}

	nrec=0;
	nbuf=read(tape,dbuf,NBUF);
	if(nbuf<0) {
		fprintf(stderr,"can't read data\n"); exit(1);
	} else if(nbuf==0) {
		fprintf(stderr,"unexpected eof in data\n"); exit(1);
	} else if(nbuf<244) {
		fprintf(stderr,"unexpected size of data\n"); exit(1);
	} else {
		mbuf=nbuf;
		ntrc=0;
		if((out=fopen((char *)str_su0,"w"))==NULL) {
			fprintf(stderr,"can't create %s\n",str_su0); exit(1);
		}
	}

rrr:	do {
		ibm_to_float(dbuf,ebuf,mbuf,240);
		if(endian==0) {
			fwrite(dbuf,sizeof(char),240,out);
		} else {
			for(i=0;i<7;++i) for(j=0;j<4;++j)
				fwrite(&dbuf[i*4-j+4-1],sizeof(char),1,out);
			for(i=0;i<4;++i) for(j=0;j<2;++j)
				fwrite(&dbuf[i*2-j+2-1+28],sizeof(char),1,out);
			for(i=0;i<8;++i) for(j=0;j<4;++j)
				fwrite(&dbuf[i*4-j+4-1+36],sizeof(char),1,out);
			for(i=0;i<2;++i) for(j=0;j<2;++j)
				fwrite(&dbuf[i*2-j+2-1+68],sizeof(char),1,out);
			for(i=0;i<4;++i) for(j=0;j<4;++j)
				fwrite(&dbuf[i*4-j+4-1+72],sizeof(char),1,out);
			for(i=0;i<46;++i) for(j=0;j<2;++j)
				fwrite(&dbuf[i*2-j+2-1+88],sizeof(char),1,out);
			for(i=0;i<7;++i) for(j=0;j<4;++j)
				fwrite(&dbuf[i*4-j+4-1+180],sizeof(char),1,out);
			for(i=0;i<16;++i) for(j=0;j<2;++j)
				fwrite(&dbuf[i*2-j+2-1+208],sizeof(char),1,out);
		}
		fwrite(ebuf,sizeof(int),(mbuf-240)/4,out);
		ntrc+=1;
	} while((nbuf=read(tape,dbuf,NBUF))==mbuf);

	if(nrec==0) {
		fclose(out);
		fprintf(stderr,"%s   : trace-data-file",str_su0);
		fprintf(stderr," : %d bytes\n",mbuf*ntrc);
		fprintf(stderr,"     %d bytes ( 240 bytes + 4 bytes x",mbuf);
		fprintf(stderr," %d samples ) x %d traces\n",(mbuf-240)/4,ntrc);
		fprintf(stderr,"  cf. segyhdrs hfile=temp.hed bfile=temp.bin");
		fprintf(stderr," <%s\n",str_su0);
		fprintf(stderr,"  cf. segywrite tape=/dev/rmt/2n ");
		fprintf(stderr," hfile=%s bfile=temp.bin <%s\n",str_asc,str_su0);
		fprintf(stderr,"    or\n");
		fprintf(stderr,"  cf. segywrite tape=/dev/rmt/2n ");
		fprintf(stderr," hfile=%s bfile=%s <%s\n",str_asc,str_bin,str_su0);
		fprintf(log,"%s   : trace-data-file",str_su0);
		fprintf(log," : %d bytes\n",mbuf*ntrc);
		fprintf(log,"     %d bytes ( 240 bytes + 4 bytes x",mbuf);
		fprintf(log," %d samples ) x %d traces\n",(mbuf-240)/4,ntrc);
		fprintf(log,"  cf. segyhdrs hfile=temp.hed bfile=temp.bin");
		fprintf(log," <%s\n",str_su0);
		fprintf(log,"  cf. segywrite tape=/dev/rmt/2n ");
		fprintf(log," hfile=%s bfile=temp.bin <%s\n",str_asc,str_su0);
		fprintf(log,"    or\n");
		fprintf(log,"  cf. segywrite tape=/dev/rmt/2n ");
		fprintf(log," hfile=%s bfile=%s <%s\n",str_asc,str_bin,str_su0);
	} else {
		fclose(out);
		fprintf(stderr,"%s   : trace-data-file",str_su1);
		fprintf(stderr," : %d bytes\n",mbuf*ntrc);
		fprintf(stderr,"     %d bytes ( 240 bytes + 4 bytes x",mbuf);
		fprintf(stderr," %d samples ) x %d traces\n",(mbuf-240)/4,ntrc);
		fprintf(stderr,"  cf. segyhdrs hfile=temp.hed bfile=temp.bin");
		fprintf(stderr," <%s\n",str_su1);
		fprintf(stderr,"  cf. segywrite tape=/dev/rmt/2n ");
		fprintf(stderr," hfile=%s bfile=temp.bin <%s\n",str_asc,str_su1);
		fprintf(stderr,"    or\n");
		fprintf(stderr,"  cf. segywrite tape=/dev/rmt/2n ");
		fprintf(stderr," hfile=%s bfile=%s <%s\n",str_asc,str_bin,str_su1);
		fprintf(log,"%s   : trace-data-file",str_su1);
		fprintf(log," : %d bytes\n",mbuf*ntrc);
		fprintf(log,"     %d bytes ( 240 bytes + 4 bytes x",mbuf);
		fprintf(log," %d samples ) x %d traces\n",(mbuf-240)/4,ntrc);
		fprintf(log,"  cf. segyhdrs hfile=temp.hed bfile=temp.bin");
		fprintf(log," <%s\n",str_su1);
		fprintf(log,"  cf. segywrite tape=/dev/rmt/2n ");
		fprintf(log," hfile=%s bfile=temp.bin <%s\n",str_asc,str_su1);
		fprintf(log,"    or\n");
		fprintf(log,"  cf. segywrite tape=/dev/rmt/2n ");
		fprintf(log," hfile=%s bfile=%s <%s\n",str_asc,str_bin,str_su1);
	}

	if(nbuf!=0) {
		if(nbuf<0) {
			fprintf(stderr,"can't read data nbuf=%d\n",nbuf);
			nbuf=read(tape,dbuf,NBUF);
			if(nbuf<=0) exit(1);
		}

		if(nbuf>0) {
			nrec+=1;
			sprintf(str_su1,"%s.%d",str_su0,nrec);
			mbuf=nbuf;
			ntrc=0;
			if((out=fopen((char *)str_su1,"w"))==NULL) {
				fprintf(stderr,"can't create %s\n",str_su1); exit(1);
			}
			goto rrr;
		}
	}

	fclose(log);
	fprintf(stderr,"%s  : log-file\n",str_log);

	close(tape);

	exit(0);
}

static void ibm_to_float(char from[], int to[], int n, int k)
{
	register int fconv, fmant, i, t, m;

	m = (n-k)/4;
	for (i=0;i<m;++i) {
		fconv  = (from[i*4+k]<<24)&0xff000000;
		fconv += (from[i*4+k+1]<<16)&0x00ff0000;
		fconv += (from[i*4+k+2]<<8)&0x0000ff00;
		fconv += (from[i*4+k+3])&0x000000ff;
		if (fconv) {
	    		fmant = 0x00ffffff & fconv;
	    		/* The next two lines were added by Toralf Foerster */
	    		/* to trap non-IBM format data i.e. conv=0 data  */
	    		if (fmant == 0) {
			fconv=0;
			/*
			fprintf(stderr,"data are not in IBM FLOAT Format !\n");
			exit(1);
			*/
			} else {		
			t = (int) ((0x7f000000 & fconv) >> 22) - 130;
			while (!(fmant & 0x00800000)) { --t; fmant <<= 1; }
			if (t > 254) fconv = (0x80000000 & fconv) | 0x7f7fffff;
			else if (t <= 0) fconv = 0;
			else fconv = (0x80000000 & fconv) |(t << 23)|(0x007fffff & fmant);
			}
		}
		to[i] = fconv;
	}
	return;
}
